// SmartIOHelper.cpp
#pragma once

#include "SmartIOHelper.h"

BOOL LoadSmartIO()
{
	RETAILMSG(TRUE,(L"\r\nLoading SMARTIO.DLL...\r\n"));
	gLibSMARTIO = LoadLibrary((L"SMARTIO.dll"));

	if(gLibSMARTIO == NULL)
	{	
		RETAILMSG(TRUE,(L"\r\nCan't find SMARTIO.DLL\r\n"));
		RETAILMSG(TRUE,(L"\r\nLoading KEYBDDR.DLL...\r\n"));
		gLibKEYBDDR = LoadLibrary((L"KEYBDDR.dll"));

		if(gLibKEYBDDR == NULL)
		{	
			RETAILMSG(TRUE,(L"\r\nFailed to load ADSmartIO library!\r\n"));
			return FALSE;
		}
		else
		{	
			RETAILMSG(TRUE,(L"\r\nKEYBDDR.DLL Loaded successfully...\r\n"));
			gLibSMARTIO = gLibKEYBDDR;
			//GraphicsClientPlus = 1;
		}
	}
	else
	{	
		RETAILMSG(TRUE,(L"\r\nSMARTIO.DLL Loaded successfully...\r\n"));
		// GraphicsMaster = 1;
	}
	if(gLibSMARTIO!=NULL)
	{	
		SIOSelectOption = (SIOSELECTOPTION)GetProcAddress(gLibSMARTIO,(L"SIOSelectOption"));
		SIOInitDDRA = (SIOINITDDRA)GetProcAddress(gLibSMARTIO,(L"SIOInitDDRA"));
		SIOInitDDRB = (SIOINITDDRB)GetProcAddress(gLibSMARTIO,(L"SIOInitDDRB"));
		SIOInitDDRC = (SIOINITDDRC)GetProcAddress(gLibSMARTIO,(L"SIOInitDDRC"));
		SIOInitDDRD = (SIOINITDDRD)GetProcAddress(gLibSMARTIO,(L"SIOInitDDRD"));
		SIOReadPortA = (SIOREADPORTA)GetProcAddress(gLibSMARTIO,(L"SIOReadPortA"));
		SIOReadPortB = (SIOREADPORTB)GetProcAddress(gLibSMARTIO,(L"SIOReadPortB"));
		SIOReadPortC = (SIOREADPORTC)GetProcAddress(gLibSMARTIO,(L"SIOReadPortC"));
		SIOReadPortD = (SIOREADPORTD)GetProcAddress(gLibSMARTIO,(L"SIOReadPortD"));
		SIOWritePortA = (SIOWRITEPORTA)GetProcAddress(gLibSMARTIO,(L"SIOWritePortA"));
		SIOWritePortB = (SIOWRITEPORTB)GetProcAddress(gLibSMARTIO,(L"SIOWritePortB"));
		SIOWritePortC = (SIOWRITEPORTC)GetProcAddress(gLibSMARTIO,(L"SIOWritePortC"));
		SIOWritePortD = (SIOWRITEPORTD)GetProcAddress(gLibSMARTIO,(L"SIOWritePortD"));
	}

	return TRUE;

}